"use strict";
/*
 * Copyright 2021-2022 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TcpDuplexConnection = void 0;
var rsocket_core_1 = require("rsocket-core");
var TcpDuplexConnection = /** @class */ (function (_super) {
    __extends(TcpDuplexConnection, _super);
    function TcpDuplexConnection(socket, frame, multiplexerDemultiplexerFactory) {
        var _this = _super.call(this) || this;
        _this.socket = socket;
        _this.remainingBuffer = Buffer.allocUnsafe(0);
        _this.handleClosed = function (hadError) {
            var message = hadError
                ? "TcpDuplexConnection: ".concat(_this.error.message)
                : "TcpDuplexConnection: Socket closed unexpectedly.";
            _this.close(new Error(message));
        };
        _this.handleError = function (error) {
            _this.error = error;
            _this.close(error);
        };
        _this.handleData = function (chunks) {
            var e_1, _a;
            try {
                // Combine partial frame data from previous chunks with the next chunk,
                // then extract any complete frames plus any remaining data.
                var buffer = Buffer.concat([_this.remainingBuffer, chunks]);
                var lastOffset = 0;
                try {
                    for (var _b = __values((0, rsocket_core_1.deserializeFrames)(buffer)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var _d = __read(_c.value, 2), frame = _d[0], offset = _d[1];
                        lastOffset = offset;
                        _this.multiplexerDemultiplexer.handle(frame);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                _this.remainingBuffer = buffer.slice(lastOffset, buffer.length);
            }
            catch (error) {
                _this.close(error);
            }
        };
        socket.on("close", _this.handleClosed);
        socket.on("error", _this.handleError);
        socket.on("data", _this.handleData);
        _this.multiplexerDemultiplexer = multiplexerDemultiplexerFactory(frame, _this);
        return _this;
    }
    Object.defineProperty(TcpDuplexConnection.prototype, "availability", {
        get: function () {
            return this.done ? 0 : 1;
        },
        enumerable: false,
        configurable: true
    });
    TcpDuplexConnection.prototype.close = function (error) {
        if (this.done) {
            _super.prototype.close.call(this, error);
            return;
        }
        this.socket.off("close", this.handleClosed);
        this.socket.off("error", this.handleError);
        this.socket.off("data", this.handleData);
        this.socket.end();
        delete this.socket;
        _super.prototype.close.call(this, error);
    };
    TcpDuplexConnection.prototype.send = function (frame) {
        if (this.done) {
            return;
        }
        var buffer = (0, rsocket_core_1.serializeFrameWithLength)(frame);
        this.socket.write(buffer);
    };
    TcpDuplexConnection.create = function (socket, connectionAcceptor, multiplexerDemultiplexerFactory) {
        var _this = this;
        // TODO: timeout on no data?
        socket.once("data", function (buffer) { return __awaiter(_this, void 0, void 0, function () {
            var _a, frame, offset, connection, error_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = __read((0, rsocket_core_1.deserializeFrames)(buffer).next().value, 2), frame = _a[0], offset = _a[1];
                        connection = new TcpDuplexConnection(socket, frame, multiplexerDemultiplexerFactory);
                        if (connection.done) {
                            return [2 /*return*/];
                        }
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        socket.pause();
                        return [4 /*yield*/, connectionAcceptor(frame, connection)];
                    case 2:
                        _b.sent();
                        socket.resume();
                        if (offset < buffer.length) {
                            connection.handleData(buffer.slice(offset, buffer.length));
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _b.sent();
                        connection.close(error_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
    };
    return TcpDuplexConnection;
}(rsocket_core_1.Deferred));
exports.TcpDuplexConnection = TcpDuplexConnection;
//# sourceMappingURL=TcpDuplexConnection.js.map